#include"Image.h"

#include<stdio.h>
#include<algorithm>
#include<string>
#include<vector>
#include<math.h>
#include<assert.h>
#include<random>
#include<queue>

using namespace std;
using lf = double;

using namespace IMAGE;

struct vec2 {
	lf x, y;
	vec2() {
		x = y = 0;
	}
	vec2(lf x, lf y) :x(x), y(y) {}

	vec2 operator +(const vec2& z) {
		return vec2(x + z.x, y + z.y);
	}
	vec2 operator -(const vec2& z) {
		return vec2(x - z.x, y - z.y);
	}
	vec2 operator *(const lf& z) {
		return vec2(x * z, y * z);
	}
	lf operator *(const vec2& z) {
		return x * z.x + y * z.y;
	}
	void normalize() {
		lf dd = sqrt(x * x + y * y);
		x /= dd;
		y /= dd;
	}
};

Image img;
Image imagespring;
Image number[10];
Image imagerobot[2];
int width = 960;
int height = 570;
lf circle_border_scale = 0.05;
lf circle_sx = 0.5;
lf circle_sy = 0.621052631579;
lf circle_width = 0.95;
lf circle_height = 0.7579;
lf spring_size = 80;
lf robot_size = 80;
lf number_size = 60;
lf robot_offset_y = spring_size * 0.6 + robot_size * 0.5;
lf line_width = 3;
lf line_offset_sy = -spring_size * 0.3;
lf line_offset_out = spring_size * 0.15 - line_offset_sy;
lf arrow_size = line_width * 4;

mt19937 rnd;
int nextint(int s, int t) {
	return (int)(rnd() % (t - s + 1)) + s;
}

void inil()
{
	int i, j, k;
	img.setsize(width, height);

	for (i = 0; i < 10; i++) {
		char xxx[99];
		sprintf(xxx, "numbers/%d.png", i);
		number[i].Load(xxx);
		//number[i].set_transparency_color(255, 255, 255, 0);
		for (int j = 0; j < number[i].h; j++) {
			for (int k = 0; k < number[i].w; k++) {
				int id = (j * number[i].w + k);
				int z = number[i].data[id * 4 + 0];
				number[i].data[id * 4 + 0] = 0;
				number[i].data[id * 4 + 1] = 0;
				number[i].data[id * 4 + 2] = 0;
				number[i].data[id * 4 + 3] = 255 - z;
			}
		}
	}

	imagespring.Load("spring1.png");
	imagespring.set_transparency_color(255, 255, 255, 0);

	imagerobot[0].Load("robot1.png");
	imagerobot[0].set_transparency_color(255, 255, 255, 0);
	imagerobot[1].Load("robot2.png");
	imagerobot[1].set_transparency_color(255, 255, 255, 0);
}
void change_spring_color() {
	int i, j, k;
	int w, h;
	w = imagespring.w;
	h = imagespring.h;
	vector<vector<bool>> vb(h, vector<bool>(w, false));
	vector<vector<vector<lf>>> vc(h, vector<vector<lf>>(w, vector<lf>(3, 0.0)));
	int dx[4] = { 0,1,0,-1 };
	int dy[4] = { 1,0,-1,0 };
	for (i = 0; i < h; i++) {
		for (j = 0; j < w; j++) {
			int id = i * w + j;
			if (vb[i][j]) continue;
			if (imagespring.data[id * 4 + 1] > 100 && imagespring.data[id * 4 + 0] < 100)
			{
				queue<int> que;
				que.push(id);
				while (!que.empty()) {
					int qi = que.front() / w;
					int qj = que.front() % w;
					que.pop();
					for (k = 0; k < 4; k++) {
						int ti = qi + dx[k];
						int tj = qj + dy[k];
					}
				}
			}
		}
	}
}

int n = 8;
int a[1000009] = {
	1, 2, 2, 2, 1, 2, 1, 2,
};
int si = 1;
int ei = 6;
void draw_base_circle() {
	int w, h;
	w = h = width * 2;

	lf border_width = w * circle_border_scale;
	lf border_rr = 255.0 / 255.0;
	lf border_gg = 203.0 / 255.0;
	lf border_bb = 49.0 / 255.0;

	Image circle(w, h);
	int tn = 10;
	for (int i = 0; i <= tn; i++) {
		circle.draw_circle_border(width, width - i * border_width / tn, width - border_width - i * border_width / tn, border_width, border_rr, border_gg, border_bb);
	}

	lf cx = (circle_sx - circle_width * 0.5) * width;
	lf cy = (circle_sy - circle_height * 0.5) * height;
	lf px = (circle_sx + circle_width * 0.5) * width;
	lf py = (circle_sy + circle_height * 0.5) * height;
	img.draw_image(cx, cy, px, py, circle);
}
void draw_spring() {
	int i, j, k;
	lf pi = acos(-1);
	for (i = 0; i < n; i++) {
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		lf ang = -pi * 0.5 + 2 * pi * i / n;
		vec2 pos = center + vec2(cos(ang) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang) * (circle_height * 0.5 - circle_border_scale) * height);
		Image spring = imagespring;
		if (a[i] == 1) {
			for (int i = 0; i < spring.h; i++) {
				for (int j = 0; j < spring.w; j++) {
					int id = i * spring.w + j;
					swap(spring.data[id * 4 + 0], spring.data[id * 4 + 1]);
				}
			}
		}
		else {
			for (int i = 0; i < spring.h; i++) {
				for (int j = 0; j < spring.w; j++) {
					int id = i * spring.w + j;
					swap(spring.data[id * 4 + 2], spring.data[id * 4 + 1]);
				}
			}
		}
		lf size = spring_size * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		img.draw_image(pos.x - size * 0.5, pos.y - size * 0.5, pos.x + size * 0.5, pos.y + size * 0.5, spring);
	}
}
void draw_first_robot() {
	int i, j, k;
	lf pi = acos(-1);
	i = si - 1;
	{
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		lf ang = -pi * 0.5 + 2 * pi * (i - 0.2) / n;
		vec2 pos = center + vec2(cos(ang) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang) * (circle_height * 0.5 - circle_border_scale) * height);
		lf size = robot_size * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		pos.y -= robot_offset_y * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		img.draw_image(pos.x - size * 0.5, pos.y - size * 0.5, pos.x + size * 0.5, pos.y + size * 0.5, imagerobot[0]);
	}
	img.mSamplingMode = SamplingModeType::SAMPLING_3x3;
	{
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		lf ang1 = -pi * 0.5 + 2 * pi * (i - 0.1) / n;
		lf ang2 = -pi * 0.5 + 2 * pi * (i - 0.9) / n;
		vec2 pos1 = center + vec2(cos(ang1) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang1) * (circle_height * 0.5 - circle_border_scale) * height);
		vec2 pos2 = center + vec2(cos(ang2) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang2) * (circle_height * 0.5 - circle_border_scale) * height);
		lf s1size = spring_size * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf s2size = spring_size * (1.0 + 0.5 * (sin(ang2) + 1.0) * 0.5);
		pos1.y -= s1size * 0.5;
		pos1.y += line_offset_sy;
		pos2.y -= s2size * 0.5;
		pos2.y += line_offset_sy;
		lf size = line_width * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf arr_size = arrow_size * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf line_out = line_offset_out * (1.0 + 0.5 * (sin(ang2) + 1.0) * 0.5);

		int tn = 100;
		for (k = 0; k < tn; k++) {
			lf s1 = (lf)k / tn;
			lf s2 = (lf)(k + 1) / tn;
			lf a1 = ang1 * (1 - s1) + ang2 * s1;
			lf a2 = ang2 * (1 - s2) + ang2 * s2;
			vec2 p1 = pos1 * (1 - s1) + pos2 * s1;
			vec2 p2 = pos1 * (1 - s2) + pos2 * s2;

			lf diff1 = (s1 - 0.5) * (s1 - 0.5) * 4.0 * (1.0 + 0.5 * (sin(a1) + 1.0) * 0.5);
			lf diff2 = (s2 - 0.5) * (s2 - 0.5) * 4.0 * (1.0 + 0.5 * (sin(a2) + 1.0) * 0.5);
			size = line_width * (1.0 + 0.5 * (sin(a1) + 1.0) * 0.5);

			p1.y += diff1 * line_offset_out;
			p2.y += diff2 * line_offset_out;

			img.draw_line(p1.x, p1.y, p2.x, p2.y, size, 0, 0, 0);
		}
		img.draw_line(pos2.x, pos2.y + line_out, pos2.x + arr_size * 0.3, pos2.y - arr_size + line_out, size, 0, 0, 0);
		img.draw_line(pos2.x, pos2.y + line_out, pos2.x + arr_size, pos2.y + arr_size * 0.3 + line_out, size, 0, 0, 0);
	}
	img.mSamplingMode = SamplingModeType::SAMPLING_CENTER;
}
void draw_second_robot() {
	int i, j, k;
	lf pi = acos(-1);
	i = ei - 1;
	{
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		lf ang = -pi * 0.5 + 2 * pi * (i - 0.2) / n;
		vec2 pos = center + vec2(cos(ang) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang) * (circle_height * 0.5 - circle_border_scale) * height);
		lf size = robot_size * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		pos.y -= robot_offset_y * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		img.draw_image(pos.x - size * 0.5, pos.y - size * 0.5, pos.x + size * 0.5, pos.y + size * 0.5, imagerobot[1]);
	}

	img.mSamplingMode = SamplingModeType::SAMPLING_3x3;
	{
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		//?? hard_coding
		center.y -= 27;

		lf ang1 = -pi * 0.5 + 2 * pi * (i - 0.1) / n;
		lf ang2 = -pi * 0.5 + 2 * pi * (i - 1.9) / n;
		vec2 pos1 = center + vec2(cos(ang1) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang1) * (circle_height * 0.5 - circle_border_scale) * height);
		vec2 pos2 = center + vec2(cos(ang2) * (circle_width * 0.5 - circle_border_scale * 1.5) * width, sin(ang2) * (circle_height * 0.5 - circle_border_scale) * height);
		lf s1size = spring_size * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf s2size = spring_size * (1.0 + 0.5 * (sin(ang2) + 1.0) * 0.5);
		pos1.y -= s1size * 0.5;
		pos1.y += line_offset_sy;
		pos2.y -= s2size * 0.5;
		pos2.y += line_offset_sy;
		lf size = line_width * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf arr_size = arrow_size * (1.0 + 0.5 * (sin(ang1) + 1.0) * 0.5);
		lf line_out = line_offset_out * (1.0 + 0.5 * (sin(ang2) + 1.0) * 0.5);

		int tn = 100;
		for (k = 0; k < tn; k++) {
			lf s1 = (lf)k / tn;
			lf s2 = (lf)(k + 1) / tn;
			lf a1 = ang1 * (1 - s1) + ang2 * s1;
			lf a2 = ang2 * (1 - s2) + ang2 * s2;
			vec2 p1 = pos1 * (1 - s1) + pos2 * s1;
			vec2 p2 = pos1 * (1 - s2) + pos2 * s2;

			lf diff1 = (s1 - 0.5) * (s1 - 0.5) * 4.0 * (1.0 + 0.5 * (sin(a1) + 1.0) * 0.5);
			lf diff2 = (s2 - 0.5) * (s2 - 0.5) * 4.0 * (1.0 + 0.5 * (sin(a2) + 1.0) * 0.5);
			size = line_width * (1.0 + 0.5 * (sin(a1) + 1.0) * 0.5);

			p1.y += diff1 * line_offset_out;
			p2.y += diff2 * line_offset_out;

			img.draw_line(p1.x, p1.y, p2.x, p2.y, size, 0, 0, 0);
		}

		img.draw_line(pos2.x, pos2.y + line_out, pos2.x - arr_size * 0.3, pos2.y - arr_size + line_out, size, 0, 0, 0);
		img.draw_line(pos2.x, pos2.y + line_out, pos2.x - arr_size, pos2.y + arr_size * 0.3 + line_out, size, 0, 0, 0);
	}
	img.mSamplingMode = SamplingModeType::SAMPLING_CENTER;
}
void draw_number() {
	int i, j, k;
	lf pi = acos(-1);
	for (i = 0; i < n; i++) {
		vec2 center = vec2(circle_sx * width, (circle_sy - circle_border_scale) * height);
		lf ang = -pi * 0.5 + 2 * pi * i / n;
		vec2 pos = center +
			vec2(cos(ang) * ((circle_width * 0.5 - circle_border_scale * 1.5) * width - number_size * 1.0),
				sin(ang) * ((circle_height * 0.5 - circle_border_scale) * height - number_size * 1.0));
		if (i == 0) { pos.y -= number_size * 0.2; }
		if (i == 3) { pos.y += number_size * 0.1; pos.x -= number_size * 0.6; }
		if (i == 5) { pos.y += number_size * 0.1; pos.x += number_size * 0.6; }
		if (i == 2) { pos.x -= number_size * 0.2; }
		if (i == 6) { pos.x += number_size * 0.2; }
		Image num = number[i + 1];
		lf size = number_size * (1.0 + 0.5 * (sin(ang) + 1.0) * 0.5);
		img.draw_image(pos.x - size * 0.5, pos.y - size * 0.5, pos.x + size * 0.5, pos.y + size * 0.5, num);
	}
}
int main() {
	int i, j, k;
	inil();
	//change_spring_color();

	draw_base_circle();
	draw_spring();
	draw_first_robot();
	draw_second_robot();
	draw_number();

	img.Save("different.png");
}